#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXM=7005;
const int MAXN=7005;
const int MOD=1102024631;

long long m,n;
long long fact[MAXM];
long long inv[MAXM];
int dp[MAXM][MAXN];

int fastPow(int x,int pw)
{
    long long ret=1;
    while(pw>0)
    {
        if(pw&1) ret*=x;
        pw>>=1;
        x=(long long)x*x%MOD;
        ret%=MOD;
    }
    return ret;
}

int inverse(int x)
{
    return fastPow(x,MOD-2);
}

int comb(int n,int k)
{
    return (fact[n]*inv[n-k]%MOD)*inv[k]%MOD;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>m>>n;

if(m<n)
{
    cout<<0<<endl;
    return 0;
}

fact[0]=1; inv[0]=1;
for(int i=1;i<=m;i++)
{
    fact[i]=fact[i-1]*i%MOD;
    inv[i]=inverse(fact[i]);
}

dp[0][0]=1;
for(int i=1;i<=n;i++)
{
    for(int j=i;j<=m-n+i;j++)
    {
        for(int k=1;k<=j-i+1;k++)
        {
            dp[i][j]+=(long long)dp[i-1][j-k]*comb(j,k)%MOD;
            if(dp[i][j]>=MOD) dp[i][j]-=MOD;
        }
    }
}

cout<<dp[n][m]<<endl;

return 0;
}
