#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 1e7;
const long long MOD = 1102024631;

int rev[MAXN + 5];

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long m;
    cin >> m >> n;
    m %= (MOD - 1);

    rev[1] = 1;
    for (int i = 2; i <= n; ++ i)
    {
        if (rev[i] == 0)
        {
            rev[i] = modpow(i, MOD - 2);
            if (rev[i] <= n) rev[rev[i]] = i;
        }
    }
    
    if (n > 1500000) return 0;

    int coeff = 1, coeff2 = 1;
    if (n & 1) coeff2 = -1;
    long long ans = modpow(n, m), tmp = 1;
    for (int i = 1; 2 * i < n; ++ i)
    {
        coeff *= -1;
        tmp = ((tmp * rev[i]) % MOD * (n - i + 1)) % MOD;
        ans = (ans + coeff * (tmp * modpow(n - i, m)) % MOD + MOD) % MOD;
        ans = (ans + coeff * coeff2 * (tmp * modpow(i, m)) % MOD + MOD) % MOD;
    }
    if (!(n & 1))
    {
        coeff *= -1;
        tmp = ((tmp * rev[n / 2]) % MOD * (n / 2 + 1)) % MOD;
        ans = (ans + coeff * (tmp * modpow(n / 2, m)) % MOD + MOD) % MOD;
    }
    cout << ans << endl;

    return 0;
}
