#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 1e7;
const int MOD = 1102024631;

int rev[MAXN + 5], mult[MAXN + 5];

pair<int, int> modpow(long long a, int b, int c)
{
    long long ret1 = 1, ret2 = 1;
    while (b)
    {
        if (b & 1) ret1 = (ret1 * a) % MOD;
        b >>= 1;
        if (c & 1) ret2 = (ret2 * a) % MOD;
        c >>= 1;
        a = (a * a) % MOD;
    }
    return {ret1, ret2};
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long m;
    cin >> m >> n;
    m %= (MOD - 1);

    for (int i = 1; i <= n; ++ i)
    {
        auto pp = modpow(i, MOD - 2, m);
        rev[i] = pp.first;
        mult[i] = pp.second;
    }

    int coeff = 1, coeff2 = 1;
    if (n & 1) coeff2 = -1;
    long long ans = mult[n], tmp = 1;
    for (int i = 1; 2 * i < n; ++ i)
    {
        coeff *= -1;
        tmp = ((tmp * rev[i]) % MOD * (n - i + 1)) % MOD;
        ans = (ans + coeff * (tmp * mult[n - i]) % MOD) % MOD;
        ans = (ans + coeff * coeff2 * (tmp * mult[i]) % MOD) % MOD;
    }
    if (!(n & 1))
    {
        coeff *= -1;
        tmp = ((tmp * rev[n / 2]) % MOD * (n / 2 + 1)) % MOD;
        ans = (ans + coeff * (tmp * mult[n / 2]) % MOD) % MOD;
    }
    ans = (ans + MOD) % MOD;
    cout << ans << endl;

    return 0;
}
