#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <deque>
#define endl '\n'
using namespace std;

const int INF = 1e9;

mt19937 rg(51933941);

deque< pair<long long, long long> > lines;

long long query(int x);
void answer(long long a, long long b);

void find_line_at(int x, bool flag)
{
    long long y1 = query(x), y2 = query(x + 1);
    long long a = y2 - y1;
    if (flag) lines.push_back({a, y1 - a * x});
    else lines.push_front({a, y1 - a * x});
    answer(a, y1 - a * x);
}

void solve(int n)
{
    int x = rg() % 1000;
    long long y1 = query(x), y2 = query(x + 1), y3 = query(x + 2);
    if (y3 - y2 == y2 - y1)
    {
        long long a = y2 - y1;
        lines.push_back({a, y1 - a * x});
        answer(a, y1 - a * x);
    }
    else
    {
        long long y4 = query(x + 3);
        long long a = y4 - y3;
        lines.push_back({a, y3 - a * (x + 2)});
        answer(a, y1 - a * x);
    }

    int l0 = x, l, r, mid;
    while (l0 < INF and lines.size() < n)
    {
        l = l0, r = INF + 1;
        int x0 = l0 + rg() % (INF - l0);
        if (query(x0) == lines.back().first * x0 + lines.back().second) l = x0;
        else r = x0;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (query(mid) == lines.back().first * mid + lines.back().second) l = mid;
            else r = mid;
        }
        if (r <= INF) find_line_at(r, true);
        l0 = r + 2;
    }

    int r0 = x;
    while (r0 > -INF and lines.size() < n)
    {
        l = -INF - 1, r = r0;
        int x0 = r0 - rg() % (r0 + INF);
        if (query(x0) == lines.front().first * x0 + lines.front().second) r = x0;
        else l = x0;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (query(mid) == lines.front().first * mid + lines.front().second) r = mid;
            else l = mid;
        }
        if (l >= -INF) find_line_at(l - 1, false);
        r0 = l - 2;
    }
}
