#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, q, p;
vector<long long> vec;
long long pref[MAXN + 5];
long long ans = 0, longest[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

void DFS(int u, int par)
{
    long long mx = 0, mxv = 0;
    for (auto [v, w] : G[u])
    {
        if (v != par)
        {
            DFS(v, u);
            if (longest[v] + w > mx)
            {
                mx = longest[v] + w;
                mxv = v;
            }
        }
    }
    longest[u] = mx;
    ///cout << u << " " << longest[u] << " " << p << endl;
    for (auto [v, w] : G[u])
    {
        if (v != par and v != mxv)
        {
            ans += longest[v] + w;
            vec.push_back(longest[v] + w);
        }
    }
}

void solve()
{
    cin >> n;

    vec.clear();
    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
        longest[i] = 0;
    }

    for (int i = 1; i < n; ++ i)
    {
        int a, b, l;
        cin >> a >> b >> l;
        G[a].push_back({b, l});
        G[b].push_back({a, l});
    }

    ans = 0;
    DFS(1, -1);
    ans += longest[1];

    sort(vec.begin(), vec.end());

    pref[0] = 0;
    for (int i = 0; i < vec.size(); ++ i)
    {
        pref[i + 1] = pref[i] + vec[i];
    }

    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        cin >> p;
        int pos = lower_bound(vec.begin(), vec.end(), p) - vec.begin();
        cout << ans + pref[pos] + 1ll * (vec.size() - pos) * p << endl;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--) solve();

    return 0;
}
