#include <algorithm>
#include <array>
#include <cmath>
#include <iostream>
#include <random>
#include <utility>
#include <vector>

#include "gcd5.h"
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T&a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T&a, const T2& b ){ return a < b ? a = b, 1 : 0;}
#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const int mod = 1e9;

struct Line{
    ll a, b;

    ll calc( ll x ){
        return a*x + b;
    }

    void print( ){
        cerr << out( a ) << out( b ) << endl;
    }
};


int inter( const Line& a, const Line& b ){
    // a*x + b = c*x + d;
    // a*x - c*x = d - b;
    // (a-c)*x = d - b
    // x = ( d - b ) / ( a - c )
    return ( b.b - a.b ) / ( a.a - b.a );
}

Line getLine( ll x1, ll y1, ll x2, ll y2 ){
    // a * x1 + b = y1
    // a * x2 + b = y2
    // a * ( x2 - x1 ) = y2 - y1;
    // a = ( y2 - y1 ) / ( x2 - x1 )


    Line curr;
    curr.a = ( y2 - y1 ) / ( x2 - x1 );
    // a * x1 + b = y1;
    // b = y1 - a*x1
    curr.b = y1 - ( curr.a * x1 );

    return curr;
}

std::vector< std::pair< ll, ll > > nas;

void f( Line l, Line r ){

    if( l.a == r.a and l.b == r.b ){
        cerr << " l == r " << endl;
        nas.push_back({ l.a, l.b });
        return;

    }

    l.print();
    r.print();

    ll xInt = inter( l, r );
    ll queryY = query( xInt );
        cerr << out( xInt ) << out( queryY ) << endl;

    ll queryYPlus = query( xInt +1 );
    ll queryYMinus = query( xInt -1 );

    if( queryY == l.calc( xInt ) and queryY == r.calc( xInt ) ){
        cerr << " nqma pravi mejdu tqh " << endl;
        nas.push_back({ l.a, l.b });
        nas.push_back({ r.a, r.b });
        return;
    }

    if( queryY == l.calc(xInt) ){
        if( queryYPlus == r.calc( xInt +1 ) ){
            // nqma pravq mejdu tqh
            cerr << " nqma pravi mejdu tqh " << endl;
            nas.push_back({ l.a, l.b });
            nas.push_back({ r.a, r.b });
            return;
        }
    }

    if( queryY == r.calc(xInt)){
        if( queryYMinus == l.calc( xInt -1 ) ){
            // nqma pravq mejdu tqh
            cerr << " nqma pravi mejdu tqh " << endl;
            nas.push_back({ l.a, l.b });
            nas.push_back({ r.a, r.b });
            return;
        }
    }

    ll yLeft = queryYMinus;
    ll yRight = queryYPlus;

    Line A = getLine( xInt, queryY, xInt-1, queryYMinus );
    Line B = getLine( xInt, queryY, xInt+1, queryYPlus );
    if( A.a == B.a and A.b == B.b ){
        // edna prava
        cerr << "enda prava " << endl;
        f( l, A );
        f( A, r );
        return;
    }

    cerr << out( xInt -1 ) << out( yLeft ) << endl;
    cerr << out( xInt +1 ) << out( yRight ) << endl;

    ll y2Left = query( xInt -2 );

    Line left2 = getLine( xInt, queryY, xInt-1, yLeft );
    Line left = getLine( xInt -1, yLeft, xInt -2, y2Left );

    Line legitLeft = left;
    Line legitRight;
    if( left2.a == left.a and left2.b == left.b ){
        // xint e ot L
        ll y2Right = query( xInt + 2);
        legitRight = getLine( xInt +1, yRight, xInt +2, y2Right );

    }else{
        // xInt e ot R
        legitRight = getLine( xInt, queryY, xInt +1, yRight );
    }

    cerr << "left ";
    legitLeft.print();
    cerr << endl << "right ";
    legitRight.print();
    cerr << endl;


    if( legitLeft.a == l.a and legitLeft.b == l.b
        and legitRight.a == r.a and legitRight.b == r.b ){
            nas.push_back({ l.a, l.b });
            nas.push_back({ r.a, r.b });
            return;

    }

    if( legitLeft.a == l.a and legitLeft.b == l.b ){
        if( !( legitRight.a == r.a and legitRight.b == r.b ) ){
            f( l, legitRight );
            f( legitRight, r );
            return;
        }
    }

    if( ( legitRight.a == r.a and legitRight.b == r.b ) ){
        if( !( legitLeft.a == l.a and legitLeft.b == l.b ) ){
            f( l, legitLeft );
            f( legitLeft, r );
            return;
        }
    }

    // 2 pravi
    cerr << " dve pravi " << endl;
    //left = getLine( xInt -1, yLeft, xInt-2, y2Left );
    //right = getLine( xInt +1, yRight, xInt +2, y2Right );

    f( legitLeft, legitRight );
}

void solve(int n){
    ll y1 = query( -mod );
    ll y2 = query( -mod +1 );
    Line left = getLine( -mod, y1, -mod+1, y2 );
    cerr << out( y1 ) << out( y2 ) << endl;

    y1 = query( mod );
    y2 = query( mod -1 );
    cerr << out( y1 ) << out( y2 ) << endl;
    Line right = getLine( mod, y1, mod-1, y2 );

    cerr << "left ";
    left.print();
    cerr << endl << "right ";
    right.print();
    cerr << endl;

    f( left, right );
    cerr << "anansko " << endl;


        for( auto j : nas ) cerr << j.first << " " << j.second << endl;
    nas.erase( std::unique( nas.begin(), nas.end() ), nas.end() );

        cerr << endl;
        for( auto j : nas ) cerr << j.first << " " << j.second << endl;


    for( auto j : nas ) answer( j.first, j.second );
}