/*
    Затвор Ловеч, София, Търново и Белене
    За Митко Мраморния, който сега е на почивка
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 7000 + 10;
const llong MOD = 1102024631;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
int dp[MAXN][MAXN];

void solve()
{
    llong fact = 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        fact = (fact * i) % MOD;
    }

    m -= n;
    if (m < 0)
    {
        std::cout << 0 << '\n';
        return;
    }

    std::fill(dp[0], dp[0] + n + 1, fact);
    for (int len = 1 ; len <= m ; ++len)
    {
        for (int last = 1 ; last <= n ; ++last)
        {
            dp[len][last] = (dp[len][last - 1] + 1LL * last * dp[len - 1][last]) % MOD;
        }
    }

    std::cout << dp[m][n] << '\n';
}

void input()
{
    std::cin >> m >> n;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}