/*
    Затвор Ловеч, София, Търново и Белене
    За Митко Мраморния, който сега е на почивка
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 1e7 + 10;
const llong MOD = 1102024631;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
llong fact[MAXN];
llong coef[MAXN];
llong ifact[MAXN];
llong dp[MAXN];

llong power(int num, llong base)
{
    if (base == 0) return 1;
    if (base & 1) return (1LL * num * power(num, base - 1)) % MOD;
    llong res = power(num, base / 2);
    return (res * res) % MOD;
}

llong comb(llong n, llong k)
{
    return (((fact[n] * ifact[k]) % MOD) * ifact[n - k]) % MOD;
}

void solve()
{
    fact[0] = 1;
    ifact[0] = 1;
    for (int i = 1 ; i <= N ; ++i)
    {
        fact[i] = (fact[i - 1] * i) % MOD;
        ifact[i] = power(fact[i], MOD - 2);
    }

    coef[0] = 1;
    llong prod = 1;
    llong sum = 0;
    llong sum2 = 1;
    llong answer = 0;
    for (int i = n ; i >= 1 ; --i)
    {
        __int128 curr = power(i, m);
        if ((n - i) % 2 == 0) answer += comb(n, n - i) * curr;
        else answer += MOD - ((comb(n, n - i) * curr) % MOD);
        answer %= MOD;
    }

    answer *= ifact[n];
    answer %= MOD;

    std::cout << answer << '\n';
}

void input()
{
    std::cin >> m >> n;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}