/*
    Затвор Ловеч, София, Търново и Белене
    За Митко Мраморния, който сега е на почивка
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, q;
// struct SegmentTree
// {
//     struct Node
//     {
//         llong value;
//         llong lazy;
//         int minIdx;

//         friend Node operator + (const Node &left, const Node &right)
//         {
//             Node result = 
//         }
//     }
// };

int par[MAXN];
llong dist[MAXN];
int parEdgeIdx[MAXN];
llong answerFor[MAXN];
std::vector <std::pair <int,int>> g[MAXN];

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        g[i].clear();
    }
}

void calcDist(int node, int p)
{
    int cnt = 0;
    par[node] = p;
    for (const auto &[u, w] : g[node])
    {
        cnt++;
        if (u == p)
        {
            continue;
        }

        dist[u] = dist[node] + w;
        parEdgeIdx[u] = cnt - 1;
        calcDist(u, node);
    }
}

void clearDist(int node)
{
    if (node != 1)
    {
        g[par[node]][parEdgeIdx[node]].second = 0;
        clearDist(par[node]);
    }
}

llong sumEdges;
llong calcFor(int people, llong p)
{
    return 2 * sumEdges - answerFor[people] + (people - 1) * p;
}

void solve()
{
    llong sumDist = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        calcDist(1, 0);
        int node = 1;

        for (int u = 2 ; u <= n ; ++u)
        {
            if (dist[u] > dist[node])
            {
                node = u;
            }
        }   

        sumDist += dist[node];
        // std::cout << sumDist << '\n';
        clearDist(node);
        answerFor[i] = sumDist;
    }

    for (int i = 1 ; i <= q ; ++i)
    {
        llong p;
        std::cin >> p;

        int l = 0, r = n, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            if (calcFor(mid, p) - calcFor(mid + 1, p) >= 0) l = mid;
            else r = mid;
        }

        std::cout << calcFor(r, p) << '\n';
    }
}

void input()
{
    sumEdges = 0;
    std::cin >> n;
    for (int i = 1 ; i < n ; ++i)
    {
        int u, v, d;
        std::cin >> u >> v >> d;
        g[u].push_back({v, d});
        g[v].push_back({u, d});
        sumEdges += d;
    }

    std::cin >> q;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIOI();
    std::cin >> tests;
    
    while (tests--)
    {
        reset();
        input();
        solve();
    }

    return 0;
}