#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e5 + 1;
const int INF = 1e9 + 7;
vector< pair<int, int> > neighbours[MAXN];
long long depth[MAXN];
void dfs(int curr, int prev) {
    for (auto it : neighbours[curr]) {
        if (it.second != prev) {
            depth[it.second] = depth[curr] + it.first;
            dfs(it.second, curr);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    long long sum = 0;
    for (int i = 1; i < n; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        neighbours[u].push_back({l, v});
        neighbours[v].push_back({l, u});
        sum += l;
    }
    depth[1] = 0;
    dfs(1, 0);
    long long maxx = 0;
    for (int i = 1; i <= n; i++) {
        maxx = max(maxx, depth[i]);
    }
    int q;
    cin >> q;
    while (q --> 0) {
        int p;
        cin >> p;
        cout << sum * 2 - maxx << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
