#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e5 + 1;
vector< pair<long long, int> > neighbours[MAXN];
long long depth[MAXN];
long long maxdep[MAXN];
long long sumlen[MAXN];
long long mincostalone[MAXN];
long long mincostfriend[MAXN];
long long mincostlast[MAXN];
bool been[MAXN];
void dfs(int curr) {
    if (been[curr]) {
        return;
    }
    been[curr] = true;
    maxdep[curr] = depth[curr];
    sumlen[curr] = 0;
    for (auto it : neighbours[curr]) {
        if (!been[it.second]) {
            depth[it.second] = depth[curr] + it.first;
            dfs(it.second);
            maxdep[curr] = max(maxdep[curr], maxdep[it.second]);
            sumlen[curr] += it.first + sumlen[it.second];
        }
    }
    mincostalone[curr] = 2 * sumlen[curr] - (maxdep[curr] - depth[curr]);
}
void calc(int curr, int prev, const long long penalty) {
    if (been[curr]) {
        return;
    }
    been[curr] = true;
    long long diff = 0;
    for (auto it : neighbours[curr]) {
        if (it.second != prev && !been[it.second]) {
            calc(it.second, curr, penalty);
            mincostfriend[curr] += min(mincostfriend[it.second] + 2 * it.first, mincostalone[it.second] + penalty + it.first);
            diff = max(diff, min(mincostfriend[it.second] + 2 * it.first, mincostalone[it.second] + penalty + it.first) - (mincostlast[it.second] + it.first));
        }
    }
    mincostlast[curr] = mincostfriend[curr] - diff;
    been[curr] = false;
}
void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v;
        long long l;
        cin >> u >> v >> l;
        neighbours[u].push_back({l, v});
        neighbours[v].push_back({l, u});
    }
    depth[1] = 0;
    dfs(1);

    int q;
    cin >> q;
    while (q --> 0) {
        for (int i = 1; i <= n; i++) {
            mincostfriend[i] = 0;
            mincostlast[i] = 0;
            been[i] = 0;
        }
        long long p;
        cin >> p;
        calc(1, 0, p);
//        for (int i = 1; i <= n; i++) {
//            cout << i << ' ' << depth[i] << ' ' << maxdep[i] << ' ' << sumlen[i] << ' ' << mincostalone[i] << ' ' << mincostfriend[i] << '\n';
//        }
        cout << mincostlast[1];
        if (q != 0) {
            cout << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}

