#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e5+10;
const long long llinf=1e18;
const long long INF=1e15;
struct Node{
    long long d;
    int x;
    long long lazy;
};
struct Prava {
    long long k;
    long long n;
    long double x;
};
Node tree[4*MAXN];
vector <Prava> env;
vector <pair <int, long long> > v[MAXN];
pair <int, long long> par[MAXN];
long long ans[MAXN], dist[MAXN];
long long res, maxs;
int in[MAXN], maxin[MAXN], idx[MAXN], in_cnt;
bool vis[MAXN];
int maxi, brch;
int n;
void merge_node(int node) {
    if (tree[node*2].d>tree[node*2+1].d) {
        tree[node].d=tree[node*2].d;
        tree[node].x=tree[node*2].x;
    } else {
        tree[node].d=tree[node*2+1].d;
        tree[node].x=tree[node*2+1].x;
    }
}
void build_tree(int node, int l, int r) {
    tree[node].lazy=0;
    if (l==r) {
        tree[node].d=dist[l];
        tree[node].x=idx[l];
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    merge_node(node);
}
void push_lazy(int node, int l, int r) {
    if (tree[node].lazy==0) return;
    tree[node].d+=tree[node].lazy;
    if (l!=r) {
        tree[node*2].lazy+=tree[node].lazy;
        tree[node*2+1].lazy+=tree[node].lazy;
    }
    tree[node].lazy=0;
}
void update(int node, int l, int r, int ql, int qr, long long ch) {
    push_lazy(node,l,r);
    if (ql>r || qr<l) return;
    if (l>=ql && r<=qr) {
        tree[node].lazy+=ch;
        push_lazy(node,l,r);
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,ql,qr,ch);
    update(node*2+1,mid+1,r,ql,qr,ch);
    merge_node(node);
}
void find_ch(int x, int p, long long sum) {
    if (p!=-1 && v[x].size()==1) brch++;
    in[x]=maxin[x]=in_cnt;
    dist[in_cnt]=sum;
    idx[in_cnt]=x;
    in_cnt++;
    for (auto i:v[x]) {
        if (i.first==p) continue;
        par[i.first]={x,i.second};
        find_ch(i.first,x,sum+i.second);
        maxin[x]=max(maxin[x],maxin[i.first]);
    }
}
void find_best() {
    auto p=tree[1];
    maxs=p.d;
    maxi=p.x;
}
void update_tree(int x) {
    while (x!=1) {
        if (vis[x]) break;
        vis[x]=true;
        update(1,1,n,in[x],maxin[x],-par[x].second);
        x=par[x].first;
    }
}
long double find_intersection(long long k1, long long n1, long long k2, long long n2) {
    long double dk, dn;
    dk=k1-k2;
    dn=n2-n1;
    return dn/dk;
}
long long findf(long long curk, long long curn, long long x) {
    return curk*x+curn;
}
void push_prava(long long curk, long long curn) {
    if (env.empty()) {
        env.push_back({curk,curn,INF});
        return;
    }
    long long lastk, lastn;
    /*
    while (env.size()>1) {
        long double lastx, curx;
        lastx=env.back().x;
        lastk=env[env.size()-2].k;
        lastn=env[env.size()-2].n;
        curx=find_intersection(curk,curn,lastk,lastn);
        if (curx<=lastx) break;
        env.pop_back();
    }*/
    lastk=env.back().k;
    lastn=env.back().n;
    //cout << env.size() << ' ' << curk << ' ' << curn << ' ' << lastk << ' ' << lastn << ' ';
    //cout <<  find_intersection(curk,curn,lastk,lastn) << endl;
    env.push_back({curk,curn,find_intersection(curk,curn,lastk,lastn)});
}
long long find_prava(long long x) {
    int l, r, mid;
    l=0; r=env.size()-1;
    while (l+1<r) {
        mid=(l+r)/2;
        if (x<=env[mid].x) l=mid;
        else r=mid;
    }
    return findf(env[l].k,env[l].n,x);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, q;
    long long a, b, c;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> n;
        for (int i=1;i<=n;i++) {
            if (!v[i].empty()) v[i].clear();
            vis[i]=false;
            par[i]={-1,-1};
        }
        if (!env.empty()) env.clear();
        res=0;
        for (int i=0;i<n-1;i++) {
            cin >> a >> b >> c;
            v[a].push_back({b,c});
            v[b].push_back({a,c});
            res+=2ll*c;
        }
        if (n>1) {
            brch=0;
            in_cnt=1;
            find_ch(1,-1,0);
            build_tree(1,1,n);
            for (int i=0;i<brch;i++) {
                find_best();
                res-=maxs;
                ans[i]=res;
                update_tree(maxi);
                push_prava(i,ans[i]);
            }
        }
        //for (int i=0;i<env.size();i++) cout << env[i].k << ' ' << env[i].n << ' ' << env[i].x << endl;
        cin >> q;
        long long p;
        for (int i=0;i<q;i++) {
            cin >> p;
            if (n==1) {
                cout << 0 << endl;
                continue;
            } else cout << find_prava(p) << endl;
        }
    }
    return 0;
}
/*
1
5
1 2 1000
1 3 1
3 4 3
3 5 4
1
4

1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
*/
