#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll Size=2e5+1,INF=1e18,mod=1102024631;

vector<pair<ll,ll> > adj[Size];
ll dist[Size],degree[Size];
bool visited[Size];
ll n;


void dfs(ll curr_node, ll depth){
    visited[curr_node]=true;
    dist[curr_node]=depth;
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node.first]){
            dfs(next_node.first,depth+next_node.second);
        }
    }
}

void reset_visited(){
    for(ll i=1;i<=n;i++){
        visited[i]=false;
    }
}

void reset(){
    for(ll i=0;i<=n;i++){
        adj[i].clear();
        visited[i]=false;
        degree[i]=0;
    }
}

void solve(){
    cin>>n;
    ll ans=0;
    for(ll i=0,from,to,weight;i<n-1;i++){
        cin>>from>>to>>weight;
        ans+=2*weight;
        adj[from].push_back({to,weight});
        adj[to].push_back({from,weight});
        degree[from]++;
        degree[to]++;
    }
    dfs(1,0);
    ll longest_line=0;
    for(ll i=1;i<=n;i++){
        if(degree[i]==1){
            longest_line=max(longest_line,dist[i]);
        }
    }
    ll q=1;
    cin>>q;
    while(q--){
        ll cost;
        cin>>cost;
        cout<<ans-longest_line<<endl;
    }
    reset();
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}
/*
4 4
1 2 1
2 3 1
3 4 1
1 4 2
*/
