#include <iostream>

#define endl '\n'

using namespace std;

const int64_t MOD = 1102024631LL;

const int MAXN = 1e5 + 3;

int64_t precalcPow[MAXN];

int64_t add_mod(int64_t &x, int64_t y) {
    x += y;

    if (x >= MOD) {
        x -= MOD;
    }
}

int64_t mul_mod(int64_t x, int64_t y) {
    return 1ll * x * y % MOD;
}

int64_t solve(int64_t m, int64_t n) {
    if (m < n) {
        return 0ll;
    }

    precalcPow[0] = 1ll;
    for (int i = 1; i < MAXN; ++i) {
        precalcPow[i] = mul_mod(precalcPow[i - 1], n);
    }

    int64_t uniqueFactorial = 1ll;
    for (int64_t i = 2; i <= n; ++i) {
        uniqueFactorial = mul_mod(uniqueFactorial, i);
    }

    int64_t leftLimit = (n > (m - n)) ? (m - n) : (m - n - 1ll);

    int64_t result = 0ll;
    for (int64_t leftSideCount = 0; leftSideCount <= leftLimit; ++leftSideCount) {
        int64_t leftSideValue = precalcPow[leftSideCount];

        if (leftSideValue > 1ll) {
            --leftSideValue;
        }

        int64_t rightSideValue = precalcPow[m - n - leftSideCount];

        int64_t currentCount = mul_mod(leftSideValue, uniqueFactorial);
        currentCount = mul_mod(currentCount, rightSideValue);

        // add_mod(result, currentCount);
    }

    return result;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int64_t m, n;
    cin >> m >> n;

    cout << solve(m, n) << endl;

    return 0;
}
