#include <iostream>

#define endl '\n'

using namespace std;

const int64_t MOD = 1102024631LL;

const int MAXN = 22;
const int MASK_LIMIT = (1 << 19) + 3;

int64_t dp[MAXN][MASK_LIMIT];

int64_t add_mod(int64_t x, int64_t y) {
    return (x + y) % MOD;
}

int64_t mul_mod(int64_t x, int64_t y) {
    return 1ll * x * y % MOD;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    int fullMask = (1 << n) - 1;

    dp[0][0] = 1ll;

    for (int days = 1; days <= m; ++days) {
        for (int currentMask = 1; currentMask <= fullMask; ++currentMask) {
            int usedPokemons = 0;

            for (int pokemon = 0; pokemon < n; ++pokemon) {
                if (currentMask & (1 << pokemon)) {
                    ++usedPokemons;
                }
            }

            if (usedPokemons > days) {
                continue;
            }

            if (usedPokemons <= days - 1) {
                dp[days][currentMask] = add_mod(dp[days][currentMask], mul_mod(dp[days - 1][currentMask], 1ll * usedPokemons));
            }

            for (int pokemon = 0; pokemon < n; ++pokemon) {
                if (currentMask & (1 << pokemon)) {
                    int previousMask = currentMask ^ (1 << pokemon);

                    dp[days][currentMask] = add_mod(dp[days][currentMask], dp[days - 1][previousMask]);
                }
            }
        }
    }

    cout << dp[m][fullMask] << endl;

    return 0;
}
