#include <iostream>

#define endl '\n'

using namespace std;

const int64_t MOD = 1102024631LL;

const int MAXN = 22;
const int MASK_LIMIT = (1 << 19) + 3;

int64_t dp[MAXN][MASK_LIMIT];

int64_t add_mod(int64_t x, int64_t y) {
    return (x + y) % MOD;
}

int64_t mul_mod(int64_t x, int64_t y) {
    return 1ll * x * y % MOD;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    dp[0][0] = 1ll;

    for (int days = 1; days <= m; ++days) {
        for (int usedPokemons = 1; usedPokemons <= min(days, n); ++usedPokemons) {
            if (usedPokemons <= days - 1) {
                dp[days][usedPokemons] = mul_mod(dp[days - 1][usedPokemons], 1ll * usedPokemons);
            }

            dp[days][usedPokemons] = add_mod(dp[days][usedPokemons], mul_mod(dp[days - 1][usedPokemons - 1], 1ll * (n - usedPokemons + 1)));
        }
    }

    cout << dp[m][n] << endl;

    return 0;
}
