#include "gcd5.h"

#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <chrono>

using namespace std;

const int MIN_A = -1e9;
const int MAX_A = 1e9;

const auto currentTime = std::chrono::system_clock::now();
const auto seed = currentTime.time_since_epoch().count();

mt19937 generator(seed);

unordered_map<int64_t, int> counter;

unordered_set<int> generatedX;
vector<pair<int, int64_t>> previousLines;

void solve(int n) {
    int foundAnswers = 0;
    int currentX = -101;

    while (foundAnswers < n) {
        /*int currentX = MAX_A + 1;

        do {
            currentX = uniform_int_distribution<int>(MIN_A, MAX_A)(generator);
        } while (generatedX.count(currentX) > 0);*/

        ++currentX;

        int64_t currentY = query(currentX);

        for (auto [previousX, previousY] : previousLines) {
            int64_t diffY = (previousX < currentX) ? (currentY - previousY) : (previousY - currentY);
            int64_t diffX = (previousX < currentX) ? 1ll * (currentX - previousX) : 1ll * (previousX - currentX);

            if (diffY % diffX != 0 or currentY == previousY) {
                continue;
            }

            int64_t currentA = diffY / diffX;

            // cout << diffY << " " << diffX << " --> " << currentA << " | " << currentY << " " << previousY << " | " << currentX << " " << previousX << endl;

            ++counter[currentA];

            if (counter[currentA] > 1) {
                break;
            }

            if (counter[currentA] == 1) {
                int64_t currentB = currentY - 1ll * currentA * currentX;

                answer(currentA, currentB);
                ++foundAnswers;

                break;
            }
        }

        generatedX.insert(currentX);
        previousLines.push_back({currentX, currentY});
    }
}
