#include <bits/stdc++.h>
#include "gcd5.h"

struct Line {
	int64_t a;
	int64_t b;
};

bool operator==(const Line &l1, const Line &l2) {
	return l1.a == l2.a && l1.b == l2.b;
}

bool operator!=(const Line &l1, const Line &l2) {
	return l1.a != l2.a || l1.b != l2.b;
}

Line line_from_xyxy(int64_t x1, int64_t y1, int64_t x2, int64_t y2) {
	if (x1 > x2) {
		std::swap(x1, x2);
		std::swap(y1, y2);
	}
	int64_t a = (y2 - y1) / (x2 - x1);
	//assert(a * (x2 - x1) == y2 - y1);
	int64_t b = y1 - a * x1;
	return {.a = a, .b = b};
}

Line line_from_queries(int64_t x1, int64_t x2) {
	int64_t y1 = query(x1);
	int64_t y2 = query(x2);
	return line_from_xyxy(x1, y1, x2, y2);
}

std::unordered_set<int64_t> answered;

void maybe_answer(int64_t a, int64_t b) {
	bool inserted = answered.insert(a << 32 | (b & 0xffffffff)).second;

	if (inserted) answer(a, b);
}

void rec(Line l1, Line l2) {
	if (l1 == l2) return;

	double x_intersect = (double) (l2.b - l1.b) / (l1.a - l2.a);

	int64_t x_l2 = floor(x_intersect);
	int64_t x_r1 = ceil (x_intersect);

	if (x_l2 == x_r1) {
		int64_t y_intersect = l1.a * x_intersect + l1.b;
	
		int64_t x_m = x_intersect;
		int64_t y_m = query(x_m);

		if (y_m == y_intersect) return;

		int64_t x_l = x_m - 1;
		int64_t y_l = query(x_l);

		int64_t x_r = x_m + 1;
		int64_t y_r = query(x_r);

		Line l_l = line_from_xyxy(x_l, y_l, x_m, y_m);
		maybe_answer(l_l.a, l_l.b);

		Line l_r = line_from_xyxy(x_m, y_m, x_r, y_r);

		if (l_r != l_l) maybe_answer(l_r.a, l_r.b);

		rec(l1, l_l);
		rec(l_r, l2);	

		return;
	}

	int64_t x_l1 = x_l2 - 1;
	int64_t x_r2 = x_r1 + 1;

	Line l_l = line_from_queries(x_l1, x_l2);
	Line l_r = line_from_queries(x_r1, x_r2);

	if (l_l != l1) maybe_answer(l_l.a, l_l.b);
	if (l_r != l_l && l_r != l2) maybe_answer(l_r.a, l_r.b);

	rec(l1, l_l);
	rec(l_r, l2);
}

void solve(int n) {
	const Line l1 = line_from_queries(-1000000000, -999999999);

	maybe_answer(l1.a, l1.b);

	if (n == 1) return;

	const Line l2 = line_from_queries(999999999, 1000000000);

	maybe_answer(l2.a, l2.b);

	if (n == 2) return;

	rec(l1, l2);		
}

/*
g++ -O2 -std=c++14 -Wl,--stack,1073741824 -Wall 2.cpp Lgrader.cpp && a
*/
