#include <bits/stdc++.h>
#include "gcd5.h"

int64_t global_n;

struct Line {
	int64_t a;
	int64_t b;
};

bool operator==(const Line &l1, const Line &l2) {
	return l1.a == l2.a && l1.b == l2.b;
}

bool operator!=(const Line &l1, const Line &l2) {
	return l1.a != l2.a || l1.b != l2.b;
}

Line line_from_xyxy(int64_t x1, int64_t y1, int64_t x2, int64_t y2) {
	if (x1 > x2) {
		std::swap(x1, x2);
		std::swap(y1, y2);
	}
	int64_t a = (y2 - y1) / (x2 - x1);
	//assert(a * (x2 - x1) == y2 - y1);
	int64_t b = y1 - a * x1;
	return {.a = a, .b = b};
}


std::unordered_set<int64_t> answered;
void maybe_answer(int64_t a, int64_t b) {
	bool inserted = answered.insert(a << 32 | (b & 0xffffffff)).second;

	if (inserted) answer(a, b);

	if (answered.size() == global_n) {
		throw std::exception();
	}
}

std::unordered_map<int64_t, int64_t> queried;
int64_t maybe_query(int64_t x) {
	const auto it = queried.find(x);
	if (it != queried.end()) {
		return it->second;
	}
	int64_t q = query(x);
	queried.insert({x, q});
	return q;
}

Line line_from_queries(int64_t x1, int64_t x2) {
	int64_t y1 = maybe_query(x1);
	int64_t y2 = maybe_query(x2);
	return line_from_xyxy(x1, y1, x2, y2);
}


void rec(Line l1, Line l2) {
	if (l1 == l2) return;

	double x_intersect = (double) (l2.b - l1.b) / (l1.a - l2.a);

	int64_t x_l2 = floor(x_intersect);
	int64_t x_r1 = ceil (x_intersect);

	int64_t x_l1 = x_l2 - 1;
	int64_t x_r2 = x_r1 + 1;

	Line l_l = line_from_queries(x_l1, x_l2);
	Line l_r = line_from_queries(x_r1, x_r2);

	maybe_answer(l_l.a, l_l.b);
	maybe_answer(l_r.a, l_r.b);

	rec(l1, l_l);
	rec(l_r, l2);
}

void real_solve() {
	const Line l1 = line_from_queries(-1000000000, -999999999);
	maybe_answer(l1.a, l1.b);

	const Line l2 = line_from_queries(999999999, 1000000000);
	maybe_answer(l2.a, l2.b);

	rec(l1, l2);
}

void solve(int n) {
	global_n = n;

	try {
		real_solve();	
	} catch(std::exception&) {
		return;
	}
}

/*
g++ -O2 -std=c++14 -Wl,--stack,1073741824 -Wall 2.cpp Lgrader.cpp && a
*/
