#include <bits/stdc++.h>

#define MAX_N 100005
#define MAX_M MAX_N

struct Edge {
	int64_t to;
	int64_t l;
	int64_t next;
};

struct Ans {
	int64_t forward;
	int64_t backward;
};

int64_t edges_idx = 1;
Edge edges[2 * MAX_N];
int64_t first_edge[MAX_N];

void add_edge(int64_t from, int64_t to, int64_t l) {
	edges[edges_idx] = {.to = to, .l = l, .next = first_edge[from]};
	first_edge[from] = edges_idx;
	edges_idx += 1;
}

Ans ans(int64_t node, int64_t parent, int64_t friend_price) {
	Ans ret = {.forward = 0, .backward = 0};

	int64_t max_backward = 0;

	for (int64_t edge = first_edge[node]; edge; edge = edges[edge].next) {
		if (edges[edge].to == parent) continue;
		Ans ans_it = ans(edges[edge].to, node, friend_price);
		ret.forward += ans_it.forward + edges[edge].l + std::min(ans_it.backward + edges[edge].l, friend_price);
		max_backward = std::max(max_backward, ans_it.backward + edges[edge].l);
	}

	ret.forward -= std::min(max_backward, friend_price);
	ret.backward = max_backward;

	// std::cerr << node << " " << ret.forward << " " << ret.backward << "\n";

	return ret;
}

void t_main() {
	int64_t n;
	std::cin >> n;

	for (int64_t n_i = 0; n_i < n - 1; n_i += 1) {
		int64_t a, b, l;
		std::cin >> a >> b >> l;
		add_edge(a, b, l);
		add_edge(b, a, l);
	}

	int64_t q;
	std::cin >> q;

	for (int q_i = 0; q_i < q; q_i += 1) {
		int64_t p;
		std::cin >> p;

		std::cout << ans(1, 0, p).forward << '\n';
	}
}

int main() {
	std::cin.tie(0);
	std::cout.tie(0);
	std::ios::sync_with_stdio(0);
	
	std::cerr << "naqalo\n";

	int64_t t;

	std::cin >> t;

	for (int64_t t_i = 0; t_i < t; t_i += 1) {
		edges_idx = 1;
		memset(first_edge, 0, sizeof(first_edge));

		t_main();
	}
}

/*
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
*/