#include <bits/stdc++.h>

#define MAX_N 100005
#define MAX_M MAX_N

struct Edge {
	int64_t to;
	int64_t l;
	int64_t next;
};

struct Ans {
	int64_t forward;
	int64_t backward;
};

int64_t edges_idx = 1;
Edge edges[2 * MAX_N];
int64_t first_edge[MAX_N];

void add_edge(int64_t from, int64_t to, int64_t l) {
	edges[edges_idx] = {.to = to, .l = l, .next = first_edge[from]};
	first_edge[from] = edges_idx;
	edges_idx += 1;
}

std::vector<int64_t> calc_backwards(int64_t node, int64_t parent) {
	std::vector<int64_t> ret;

	for (int64_t edge = first_edge[node]; edge; edge = edges[edge].next) {
		if (edges[edge].to == parent) continue;
		std::vector<int64_t> it = calc_backwards(edges[edge].to, node);

		it[it.size()-1] += edges[edge].l;

		ret.insert(ret.end(), it.begin(), it.end());
	}

	std::sort(ret.begin(), ret.end());
	
	if (ret.size() == 0) ret.push_back(0);

	return ret;
}

void t_main() {
	int64_t n;
	std::cin >> n;

	int64_t forward = 0;

	for (int64_t n_i = 0; n_i < n - 1; n_i += 1) {
		int64_t a, b, l;
		std::cin >> a >> b >> l;
		add_edge(a, b, l);
		add_edge(b, a, l);

		forward += l;
	}

	std::vector<int64_t> backwards = calc_backwards(1, 0);
	backwards.pop_back();
	std::vector<int64_t> cumsum(backwards.size() + 1);

	cumsum[0] = 0;

	for (int64_t i = 1; i < cumsum.size(); i += 1) {
		cumsum[i] = cumsum[i-1] + backwards[i-1];
	}

	int64_t q;
	std::cin >> q;

	for (int q_i = 0; q_i < q; q_i += 1) {
		int64_t p;
		std::cin >> p;
		
		int64_t greater_idx = std::equal_range(backwards.begin(), backwards.end(), p).second - backwards.begin();
		
		std::cout << forward + cumsum[greater_idx] + (backwards.size() - greater_idx) * p << '\n';
	}
}

int main() {
	std::cin.tie(0);
	std::cout.tie(0);
	std::ios::sync_with_stdio(0);
	
	std::cerr << "naqalo\n";

	int64_t t;

	std::cin >> t;

	for (int64_t t_i = 0; t_i < t; t_i += 1) {
		edges_idx = 1;
		memset(first_edge, 0, sizeof(first_edge));

		t_main();
	}
}

/*
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
*/