#include "gcd5.h"
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
struct point
{
    ll x, y;

    point (ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const ll inf = 1e9;
struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    void init_line(point A, point B)
    {
        k = (B.y - A.y) / (B.x - A.x);
        /// k * A.x + m = A.y
        m = A.y - k * A.x;
    }

    ll calc(ll x)
    {
        return k * x + m;
    }
};

bool same_line(line l1, line l2)
{
    if (l1.k == l2.k && l1.m == l2.m)
        return true;
    return false;
}

double intersect(line l1, line l2)
{
    /// l1.k * x + l1.m = l2.k * x + l2.m
    /// (l1.k - l2.k) * x = l2.m - l1.m
    /// x = (l2.m - l1.m) / (l1.k - l2.k)
    return (double)(l2.m - l1.m) / (double)(l1.k - l2.k);
}
void  fun(ll lf, ll rf, line leftmost, line rightmost)
{
    double supposed_x = intersect(leftmost, rightmost);
    ll x = ceil(supposed_x);
    vector < ll > imp;
    assert(x - 3 >= -inf && x + 3 <= inf);
    for (ll i = x - 3; i <= x + 3; i ++)
        imp.push_back(i);

    vector < ll > y_values;
    for (int i = 0; i < (int)imp.size(); i ++)
        y_values.push_back(query(imp[i]));

    vector < pair < int, line > > found;

    for (int i = 0; i < (int)imp.size() - 2; i ++)
    {
        line cur;
        cur.init_line(point(imp[i], y_values[i]), point(imp[i + 1], y_values[i + 1]));
        if (cur.calc(imp[i + 2]) == y_values[i + 2])
            found.push_back({imp[i + 2], cur});
    }

    for (int i = 0; i < (int)found.size(); i ++)
    {
        line cur = found[i].second;
        ///cout << "found " << cur.k << " " << cur.m << endl;
        if (!same_line(cur, leftmost) && !same_line(cur, rightmost))
        {
            answer(cur.k, cur.m);
            fun(lf, found[i].first, leftmost, cur);
            fun(found[i].first, rf, cur, rightmost);
            break;
        }
    }

}
void solve(int n)
{
    line leftmost, rightmost;
    leftmost.init_line(point(-inf, query(-inf)), point(-inf + 1, query(-inf + 1)));
    rightmost.init_line(point(inf - 1, query(inf - 1)), point(inf, query(inf)));
    answer(leftmost.k, leftmost.m);
    answer(rightmost.k, rightmost.m);
    fun(-inf, inf, leftmost, rightmost);
}
