#include "gcd5.h"
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
struct point
{
    ll x, y;

    point (ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const ll inf = 1e9;
struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    void init_line(point A, point B)
    {
        k = (B.y - A.y) / (B.x - A.x);
        /// k * A.x + m = A.y
        m = A.y - k * A.x;
    }

    ll calc(ll x)
    {
        return k * x + m;
    }
};

bool same_line(line l1, line l2)
{
    if (l1.k == l2.k && l1.m == l2.m)
        return true;
    return false;
}

double intersect(line l1, line l2)
{
    /// l1.k * x + l1.m = l2.k * x + l2.m
    /// (l1.k - l2.k) * x = l2.m - l1.m
    /// x = (l2.m - l1.m) / (l1.k - l2.k)

    return (double)(l2.m - l1.m) / (double)(l1.k - l2.k);
}

unordered_map < ll, ll > used, act;
ll Query(ll x)
{
    if (used[x])
        return act[x];
        used[x] = 1;
        act[x] = query(x);
        return act[x];
}
int cnt, N;
void  fun(ll lf, ll rf, line leftmost, line rightmost)
{
    if (leftmost.k == rightmost.k - 1)
        return;
    if (cnt == N)
        return;

    double supposed_x = intersect(leftmost, rightmost);
    ll x = ceil(supposed_x);
    ll val1, val2;
        val2 = Query(x);
        if (leftmost.calc(x) == rightmost.calc(x) &&
            leftmost.calc(x) == val2)
        {
            return;
        }
    val1 = Query(x - 1);


    if (val1 == leftmost.calc(x - 1) && val2 == rightmost.calc(x))
        return;

    if (val1 == leftmost.calc(x - 1))
    {
        ll x1 = x;
        ll x2 = x + 1;
        line cur;
        cur.init_line(point(x1, Query(x1)), point(x2, Query(x2)));
        cnt ++;
        answer(cur.k, cur.m);
        fun(lf, x, leftmost, cur);
        fun(x, rf, cur, rightmost);
        return;
    }

    if (val2 == rightmost.calc(x))
    {
        ll x1 = x - 2;
        ll x2 = x - 1;
        line cur;
        cur.init_line(point(x1, Query(x1)), point(x2, Query(x2)));
        cnt ++;
        answer(cur.k, cur.m);
        fun(lf, x - 1, leftmost, cur);
        fun(x - 1, rf, cur, rightmost);
        return;
    }


    vector < ll > imp;
    //imp.push_back(x - 3);
    imp.push_back(x - 2);
    imp.push_back(x - 1);
    imp.push_back(x);
    //imp.push_back(x + 2);

    vector < ll > values;
    ///values.push_back(Query(x - 3));
    values.push_back(Query(x - 2));
    values.push_back(val1);
    values.push_back(val2);
    ///values.push_back(Query(x + 2));

    for (int i = 0; i < (int)(imp.size()) - 2; i ++)
    {
        line cur;
        cur.init_line(point(imp[i], values[i]), point(imp[i + 1], values[i + 1]));
        if (cur.calc(imp[i + 2]) == values[i + 2])
        {
            cnt ++;
            answer(cur.k, cur.m);
            fun(lf, imp[i + 1], leftmost, cur);
            fun(imp[i + 1], rf, cur, rightmost);
            return;
        }
    }
    line cur;
    cur.init_line(point(x - 2, Query(x - 2)), point(x - 1, Query(x - 1)));
    answer(cur.k, cur.m);
    fun(lf, x, leftmost, cur);
    fun(x, rf, cur, rightmost);





}
void solve(int n)
{
    line leftmost, rightmost;
    leftmost.init_line(point(-inf, Query(-inf)), point(-inf + 1, Query(-inf + 1)));
    rightmost.init_line(point(inf - 1, Query(inf - 1)), point(inf, Query(inf)));
    answer(leftmost.k, leftmost.m);
    answer(rightmost.k, rightmost.m);
    cnt = 2;
    fun(-inf, inf, leftmost, rightmost);
}
