#include "gcd5.h"
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
struct point
{
    ll x, y;

    point (ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const ll inf = 1e9;
struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    void init_line(point A, point B)
    {
        k = (B.y - A.y) / (B.x - A.x);
        /// k * A.x + m = A.y
        m = A.y - k * A.x;
    }

    ll calc(ll x)
    {
        return k * x + m;
    }
};

bool same_line(line l1, line l2)
{
    if (l1.k == l2.k && l1.m == l2.m)
        return true;
    return false;
}

double intersect(line l1, line l2)
{
    /// l1.k * x + l1.m = l2.k * x + l2.m
    /// (l1.k - l2.k) * x = l2.m - l1.m
    /// x = (l2.m - l1.m) / (l1.k - l2.k)

    return (double)(l2.m - l1.m) / (double)(l1.k - l2.k);
}

unordered_map < ll, ll > used, act;
ll Query(ll x)
{
    if (used[x])
        return act[x];
    used[x] = 1;
    act[x] = query(x);
    return act[x];
}
int cnt, N;
struct funny
{
    ll lf, rf;
    line leftmost;
    line rightmost;

    funny(ll _lf, ll _rf, line _leftmost, line _rightmost)
    {
        lf = _lf;
        rf = _rf;
        leftmost = _leftmost;
        rightmost = _rightmost;
    }
};

queue < funny > q;
void  fun()
{
    ll lf, rf;
    line leftmost, rightmost;
    lf = q.front().lf;
    rf = q.front().rf;
    leftmost = q.front().leftmost;
    rightmost = q.front().rightmost;
    q.pop();
    if (leftmost.k == rightmost.k - 1)
        return;
    if (cnt == N)
        return;
        if (rf - lf < 3)
            return;

    double supposed_x = intersect(leftmost, rightmost);
    ll x = ceil(supposed_x);
    ll val1, val2;
    val2 = Query(x);
    if (leftmost.calc(x) == rightmost.calc(x) &&
            leftmost.calc(x) == val2)
    {
        return;
    }
    val1 = Query(x - 1);


    if (val1 == leftmost.calc(x - 1) && val2 == rightmost.calc(x))
        return;

    if (val1 == leftmost.calc(x - 1))
    {
        ll x1 = x;
        ll x2 = x + 1;
        line cur;
        cur.init_line(point(x1, Query(x1)), point(x2, Query(x2)));
        cnt ++;
        answer(cur.k, cur.m);

        q.push(funny(x, rf, cur, rightmost));
        q.push(funny(lf, x, leftmost, cur));
        //fun(x, rf, cur, rightmost);
        //fun(lf, x, leftmost, cur);

        return;
    }

    if (val2 == rightmost.calc(x))
    {
        ll x1 = x - 2;
        ll x2 = x - 1;
        line cur;
        cur.init_line(point(x1, Query(x1)), point(x2, Query(x2)));
        cnt ++;
        answer(cur.k, cur.m);
        q.push(funny(lf, x - 1, leftmost, cur));
        q.push(funny(x - 1, rf, cur, rightmost));
        //fun(lf, x - 1, leftmost, cur);
        //fun(x - 1, rf, cur, rightmost);
        return;
    }


    line l1;
    l1.init_line(point(x - 2, Query(x - 2)), point(x - 1, Query(x - 1)));
    if (l1.calc(x) == Query(x))
    {
        answer(l1.k, l1.m);
        q.push(funny(lf, x - 1, leftmost, l1));
        q.push(funny(x - 1, rf, l1, rightmost));
        //fun(lf, x - 1, leftmost, l1);
        //fun(x - 1, rf, l1, rightmost);
        return;
    }

    line l2;
    l2.init_line(point(x, Query(x)), point(x + 1, Query(x + 1)));

    if (l2.calc(x - 1) == Query(x - 1))
    {
        answer(l2.k, l2.m);
        q.push(funny(x + 1, rf, l2, rightmost));
        q.push(funny(lf, x + 1, leftmost, l2));
        //fun(x + 1, rf, l2, rightmost);
        //fun(lf, x + 1, leftmost, l2);

        return;
    }

    answer(l1.k, l1.m);
    answer(l2.k, l2.m);
    q.push(funny(x + 1, rf, l2, rightmost));
    q.push(funny(lf, x - 2, leftmost, l1));
    //fun(x + 1, rf, l2, rightmost);
    //fun(lf, x - 2, leftmost, l1);





}
void solve(int n)
{
N = n;
    line leftmost, rightmost;

    leftmost.init_line(point(-inf, Query(-inf)), point(-inf + 1, Query(-inf + 1)));
    rightmost.init_line(point(inf - 1, Query(inf - 1)), point(inf, Query(inf)));
    answer(leftmost.k, leftmost.m);
    answer(rightmost.k, rightmost.m);
    cnt = 2;
    q.push(funny(-inf, inf, leftmost, rightmost));
    //fun(-inf, inf, leftmost, rightmost);
    fun();
}
