#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;

struct edge
{
    int v, u;
    ll w;

    edge(int _v = 0, int _u = 0, ll _w = 0)
    {
        v = _v;
        u = _u;
        w = _w;
    }
}edges[maxn];


int n, q;
vector < pair < int, int > > adj[maxn];
void input()
{
    cin >> n;
    for (int i = 1; i < n; i ++)
    {
        cin >> edges[i].v >> edges[i].u >> edges[i].w;
        adj[edges[i].v].push_back({edges[i].u, i});
        adj[edges[i].u].push_back({edges[i].v, i});
    }
}

ll depth[maxn];
int par[maxn], ridx[maxn];
void calc_depth(int v, int p, int last)
{
    par[v] = p;
    ridx[v] = last;
    for (pair < int, int > nb : adj[v])
    {
        int u = nb.first;
        if (u == p)
            continue;
        depth[u] = depth[v] + edges[nb.second].w;
        calc_depth(u, v, nb.second);
    }
}

int find_deepest()
{
        int ver = -1;
    for (int i = 1; i <= n; i ++)
        if (ver == -1 || depth[i] > depth[ver])
            ver = i;
    return ver;
}

void remove_path(int v)
{
    while(v != 1)
    {
        edges[ridx[v]].w = 0;
        v = par[v];
    }
}

void clear_data()
{
    for (int i = 1; i <= n; i ++)
    {
        depth[i] = par[i] = ridx[i] = 0;
        edges[i] = edge();
        adj[i].clear();
    }
}
void solve_query()
{
    cin >> q;
    assert(q == 1);
    ll p;
    cin >> p;
    ll res = 0;
    for (int i = 1; i < n; i ++)
        res = res + 2 * edges[i].w;
    ///cout << res << endl;
    calc_depth(1, -1, -1);
    ll ver = find_deepest();
    res = res - depth[ver];
    remove_path(ver);

    while(true)
    {
        calc_depth(1, -1, -1);
        ver = find_deepest();
        if (ver == -1)
            break;
        if (depth[ver] > p)
        {
            res = res - depth[ver] + p;
            remove_path(ver);
        }
        else
        {
            break;
        }
    }

    cout << res << endl;
}
void solve()
{
    input();
    solve_query();
    clear_data();
}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
1
10

*/
