#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;
const ll inf = 1e18;

struct edge
{
    int v, u;
    ll w;

    edge(int _v = 0, int _u = 0, ll _w = 0)
    {
        v = _v;
        u = _u;
        w = _w;
    }
}edges[maxn];


int n, q;
vector < pair < int, int > > adj[maxn];
void input()
{
    cin >> n;
    for (int i = 1; i < n; i ++)
    {
        cin >> edges[i].v >> edges[i].u >> edges[i].w;
        adj[edges[i].v].push_back({edges[i].u, i});
        adj[edges[i].u].push_back({edges[i].v, i});
    }
}

ll depth[maxn];
int par[maxn], ridx[maxn];
int tin[maxn], tout[maxn], timer, ord[maxn];
int used[maxn];
void calc_depth(int v, int p, int last)
{
    tin[v] = ++ timer;
    ord[timer] = v;
    par[v] = p;
    ridx[v] = last;
    for (pair < int, int > nb : adj[v])
    {
        int u = nb.first;
        if (u == p)
            continue;
        depth[u] = depth[v] + edges[nb.second].w;
        calc_depth(u, v, nb.second);
    }
    tout[v] = timer;
}


struct node
{
    int pos;
    ll mx;

    node(int _pos = -1, ll _mx = -inf)
    {
        pos = _pos;
        mx = _mx;
    }
};

node merge_nodes(node lf, node rf)
{
    if (lf.mx > rf.mx)
        return lf;
    return rf;
}

node tree[4 * maxn];
ll lazy[4 * maxn];
void build_tree(int root, int left, int right)
{
    lazy[root] = 0;
    if (left == right)
    {
        tree[root] = node(ord[left], depth[ord[left]]);
        return;
    }

    int mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}

void push_lazy(int root, int left, int right)
{
    tree[root].mx += lazy[root];

    if (left != right)
    {
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
    }

    lazy[root] = 0;
}

void update(int root, int left, int right, int qleft, int qright, ll val)
{

    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return;
    if (left >= qleft && right <= qright)
    {
        lazy[root] += val;
        push_lazy(root, left, right);
        return;
    }

    int mid = (left + right) / 2;
    update(root * 2, left, mid, qleft, qright, val);
    update(root * 2 + 1, mid + 1, right, qleft, qright, val);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}


void clear_data()
{
    for (int i = 1; i <= 4 * n; i ++)
        tree[i] = node(), lazy[i] = 0;
    for (int i = 1; i <= n; i ++)
    {
        depth[i] = par[i] = ridx[i] = 0;
        edges[i] = edge();
        adj[i].clear();
        tin[i] = tout[i] = 0;
        ord[i] = 0;
        used[i] = 0;
    }
    timer = 0;
}


ll values[maxn], pref[maxn];
int to;



void remove_path(int v)
{
    while(!used[v])
    {
        update(1, 1, n, tin[v], tout[v], - edges[ridx[v]].w);
        ///edges[ridx[v]].w = 0;
        used[v] = 1;
        v = par[v];
    }
}

void precompute()
{
    to = 0;
    used[1] = 1;
    build_tree(1, 1, n);

    while(true)
    {
        ///cout << "here " << tree[1].mx << endl;
        if (tree[1].mx == 0)
            break;
        values[++ to] = (tree[1].mx);
        remove_path(tree[1].pos);
    }

    for (int i = 1; i <= to; i ++)
    {
        pref[i] = pref[i - 1] + values[i];
    }
}
void answer_queries()
{
    cin >> q;
    ll base = 0;
    for (int i = 1; i < n; i ++)
        base = base + 2 * edges[i].w;

    for (int i = 1; i <= q; i ++)
    {
        ll price;
        cin >> price;
        int lf = 2, rf = to;
        while(lf <= rf)
        {
            int mf = (lf + rf)/  2;
            if (values[mf] > price)
                lf = mf + 1;
            else
                rf = mf - 1;
        }

        ll res = base - pref[rf] + (ll)(rf - 1) * price;
        cout << res << endl;

    }

}
void solve()
{
    input();
    calc_depth(1, -1, -1);
    precompute();
    answer_queries();
    clear_data();
}

int main()
{
    speed();
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
2
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
3
10
15
20

*/
