#include<bits/stdc++.h>
using namespace std;
const int maxn = 7010;
const int mod = 1102024631;

long long dp[maxn][maxn];
long long fact[maxn], invfact[maxn];
int n, m;

long long fast_pow(long long x, long long p){
    long long rez = 1;
    while (p){
        if (p & 1)
            rez = (rez * x) % mod;
        p /= 2;
        x = (x * x) % mod;
    }
    return rez;
}

void init_fact_and_inv_fact(){
    fact[0] = 1;
    for (int i = 1; i <= n + 1; ++i)
        fact[i] = (fact[i - 1] * i) % mod;
    invfact[n + 1] = fast_pow(fact[n + 1], mod - 2);
    for (int i = n ; i >= 0; --i)
        invfact[i] = (invfact[i + 1] * (long long)(i + 1)) % mod;
}

long long comb_n_k(int n, int k){
    return (((fact[n] * invfact[k]) % mod) * invfact[n - k]) % mod;
}

void solve(){
    dp[0][0] = 1;
    dp[1][1] = n;
    //cout << dp[1][1] << " " << comb_n_k(n, 2) << endl;
    for (int i = 2; i <= m; ++i){
        for (int j = 1; j <= i && j <= n; ++j){
            //dp[i][j] += (dp[i - 1][j - 1] * comb_n_k(n, n - j + 1)) % mod;
            dp[i][j] += (dp[i - 1][j - 1] * (long long)(n - j + 1)) % mod;
            dp[i][j] %= mod;
            dp[i][j] += (dp[i - 1][j] * (long long)j) % mod;
            dp[i][j] %= mod;
        }
    }
    cout << dp[m][n] << endl;
}

int main(){
    cin >> m >> n;
    init_fact_and_inv_fact();
    solve();
    //cout << comb_n_k(10, 5) << endl;
    return 0;
}

/*cin >> n;
    init_fact_and_inv_fact();
    for (int i = 0; i <= n; ++i)
        cout << comb_n_k(n, i) << " ";
    cout << endl;*/
