#pragma once
#include "gcd5.h"

using namespace std;
const int maxx = 1e9;

int bs_get_intersection_point(int x0, long long slope, long long b){
    int l = x0, r = 1e9 + 1, mid;
    ///l: the rightest x which is on the line and applies to the condition of being a maximum
    ///r: the leftest x which is not on the line and applies to the condition of being a maximum
    long long ymid, yline;
    while (l + 1 < r){
        mid  = (l + r) / 2;
        ymid = query(mid);
        yline = slope * mid + b;
        if (ymid == yline)
            l = mid;
        else r = mid;
    }
    return r;
}

void solve(int n) {
    int intersectp = -maxx;
    int x0, x1;
    long long y0, y1, slope, b;
    for (int line = 0; line < n; ++line){
        x0 = intersectp;
        x1 = intersectp + 1;
        y0 = query(x0);
        y1 = query(x1);
        slope = (y1 - y0);
        b = y0 - (long long)x0 * (long long)slope;
        answer(slope, b);
        if (line == n - 1)
            break;
        intersectp = bs_get_intersection_point(x1, slope, b);
    }
}
/*
g++ -O2 -std=c++17 -Wl,--stack,1073741824 -Wall gcd5.cpp Lgrader.cpp -o gcd5.exe
*/
