#pragma once
#include "gcd5.h"
#include<algorithm>
#include<iostream>

using namespace std;
const int maxx = 1e9;

int bs_get_intersection_point_rigth_dir(int lb, int rb, long long slope, long long b){
    int l = lb, r = rb, mid;
    ///l: the rightest x which is on the line and applies to the condition of being a maximum
    ///r: the leftest x which is not on the line and applies to the condition of being a maximum
    long long ymid, yline;
    while (l + 1 < r){
        mid  = (l + r) / 2;
        ymid = query(mid);
        yline = slope * mid + b;
        if (ymid == yline)
            l = mid;
        else r = mid;
    }
    return l;
}

int bs_get_intersection_point_left_dir(int lb, int rb, long long slope, long long b){
    int l = lb, r = rb, mid;
    ///l: the rightest x which is not on the line and applies to the condition of being a maximum
    ///r: the leftest x which is on the line and applies to the condition of being a maximum
    long long ymid, yline;
    while (l + 1 < r){
        mid  = (l + r) / 2;
        ymid = query(mid);
        yline = slope * mid + b;
        if (ymid == yline)
            r = mid;
        else l = mid;
    }
    return r;
}

inline void get_slope_and_b(int x0, int x1, long long y0, long long y1, long long &slope, long long &b){
    if (x0 > x1){
        swap(x0, x1);
        swap(y0, y1);
    }
    /*y0 = query(x0);
    y1 = query(x1);*/
    slope = y1 - y0;
    b = y0 - (long long)x0 * slope;
}

/*void solve(int n){
    if (n == 1){
        int x0 = -maxx;
        int x1 = x0 + 1;
        long long y0 = query(x0);
        long long y1 = query(x1);
        long long slope, b;
        get_slope_and_b(x0, x1, y0, y1, slope, b);
        answer(slope, b);
        return;
    }

    int xl0 = -maxx;
    int xl1 = xl0 + 1;
    long long yl0, yl1, slopel, bl;
    yl0 = query(xl0);
    yl1 = query(xl1);
    get_slope_and_b(xl0, xl1, yl0, yl1, slopel, bl);
    answer(slopel, bl);

    int xr0 = maxx;
    int xr1 = xr0 - 1;
    long long yr0, yr1, sloper, br;
    yr0 = query(xr0);
    yr1 = query(xr1);
    get_slope_and_b(xr0, xr1, yr0, yr1, sloper, br);
    answer(sloper, br);

    for (int line = 2; line <= n / 2; ++line){
        xl0 = bs_get_intersection_point_rigth_dir(xl1, maxx, slopel, bl);
        xl1 = xl0 + 1;
        yl0 = (long long)xl0 * slopel + bl;
        yl1 = query(xl1);
        get_slope_and_b(-maxx, xl1, yl0, yl1, slopel, bl);
        answer(slopel, bl);

        xr0 = bs_get_intersection_point_left_dir(xl1, xr1, sloper, br);
        xr1 = xr0 - 1;
        yr0 = (long long)xr0 * sloper + br;
        yr1 = query(xr1);
        get_slope_and_b(xr0, xr1, yr0, yr1, sloper, br);
        answer(sloper, br);
    }

    if (n % 2){
        xl0 = bs_get_intersection_point_rigth_dir(xl1, maxx, slopel, bl);
        xl1 = xl0 + 1;
        yl0 = (long long)xl0 * slopel + bl;
        yl1 = query(xl1);
        get_slope_and_b(xl0, xl1, yl0, yl1, slopel, bl);
        answer(slopel, bl);
    }
}*/


int bs_get_intersection_point(int lb, int rb, long long slope, long long b){
    int l = lb, r = rb, mid;
    ///l: the rightest x which is on the line and applies to the condition of being a maximum
    ///r: the leftest x which is not on the line and applies to the condition of being a maximum
    ///both l and r lay on the next maximum line
    long long ymid, yline;
    while (l + 1 < r){
        mid  = (l + r) / 2;
        ymid = query(mid);
        yline = slope * mid + b;
        if (ymid == yline)
            l = mid;
        else r = mid;
    }
    return l;
}

void solve(int n) {
    //cout << "Here 1:\n";
    int intersectp = -maxx;
    int x0, x1;
    long long y0, y1, slope, b;
    for (int line = 0; line < n; ++line){

        x0 = intersectp;
        x1 = intersectp + 1;
        y0 = query(x0);
        y1 = query(x1);
        slope = (y1 - y0);
        b = y0 - (long long)x0 * (long long)slope;
        answer(slope, b);
        if (line == n - 1)
            break;
        intersectp = bs_get_intersection_point_rigth_dir(x1, maxx, slope, b);
        //cout << "intersectp: " << intersectp << endl;
    }
}
