#pragma once
#include "gcd5.h"
#include<algorithm>
#include<iostream>
#include<queue>
#include<cassert>
#include<set>

using namespace std;
const int maxx = 1e9;

inline void get_slope_and_b(int x0, int x1, long long y0, long long y1, long long &slope, long long &b){
    if (x0 > x1){
        swap(x0, x1);
        swap(y0, y1);
    }
    /*y0 = query(x0);
    y1 = query(x1);*/
    slope = y1 - y0;
    b = y0 - (long long)x0 * slope;
}

int find_intersection(long long slope1, long long b1, long long slope2, long long b2){
    assert((b2 - b1)%(slope1 - slope2) == 0);
    return (b2 - b1) / (slope1 - slope2);
}

void solve(int n){
    //cerr << "here1\n";
    if (n == 1){
        int x0 = -maxx;
        int x1 = x0 + 1;
        long long y0 = query(x0);
        long long y1 = query(x1);
        long long slope, b;
        get_slope_and_b(x0, x1, y0, y1, slope, b);
        answer(slope, b);
        return;
    }

    set<pair<long long, long long> > answered_lines;

    int xl0 = -maxx;
    int xl1 = xl0 + 1;
    long long yl0, yl1, slopel, bl;
    yl0 = query(xl0);
    yl1 = query(xl1);
    get_slope_and_b(xl0, xl1, yl0, yl1, slopel, bl);
    answered_lines.insert({slopel, bl});
    //answer(slopel, bl);

    int xr0 = maxx;
    int xr1 = xr0 - 1;
    long long yr0, yr1, sloper, br;
    yr0 = query(xr0);
    yr1 = query(xr1);
    get_slope_and_b(xr0, xr1, yr0, yr1, sloper, br);
    answered_lines.insert({sloper, br});
    //answer(sloper, br);

    /*if (n == 2)
        return;*/
    queue< pair<pair<long long, long long>, bool > > q;
    q.push({{slopel, bl}, true});
    while (answered_lines.size() < n && !q.empty()){
        pair<pair<long long, long long>, bool> cur = q.front();
        q.pop();
        long long slopel, bl;
        long long sloper, br;
        if (cur.second == true){
            slopel = cur.first.first;
            bl = cur.first.second;
            auto it = answered_lines.find({slopel, bl});
            it++;
            sloper = it->first;
            br = it->second;
        }
        else{
            sloper = cur.first.first;
            br = cur.first.second;
            auto it = answered_lines.find({sloper, br});
            it--;
            slopel = it->first;
            bl = it->second;
        }
        int x0 = find_intersection(slopel, bl, sloper, br);
        int xl = x0 - 1;
        int xr = x0 + 1;
        long long y0 = query(x0);
        long long yl = query(xl);
        long long yr = query(xr);
        if (yl - y0 == y0 - yr){
            ///three dots on one line
            long long slopenew, bnew;
            get_slope_and_b(x0, xr, y0, yr, slopenew, bnew);
            answered_lines.insert({slopenew, bnew});
            q.push({{slopenew, bnew}, false});
            q.push({{slopenew, bnew}, true});
        }
        else{
            long long slopenew, bnew;
            get_slope_and_b(xl, x0, yl, y0, slopenew, bnew);
            answered_lines.insert({slopenew, bnew});
            q.push({{slopenew, bnew}, false});

            get_slope_and_b(x0, xr, y0, yr, slopenew, bnew);
            answered_lines.insert({slopenew, bnew});
            q.push({{slopenew, bnew}, true});
        }
    }
    //cerr << "out of the while()\n";
    //cerr << "anslines.size(): " << answered_lines.size() << "\n";
    assert(answered_lines.size() == n);

    for (auto it = answered_lines.begin(); it != answered_lines.end(); ++it){
        //cout << it->first << " " << it->second << "\n";
        answer(it->first, it->second);
    }

}
