#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100008
using namespace std;

struct Edge
{
    int e, w, nom;
};

vector<Edge> edges[MAXN];
int brMinavane[MAXN];
int p;
int ans;

int dist[MAXN];
queue<int> q;
int fLeaf = -1;
int longest = 0;
bool dfsFindLongest(int curr)
{
    if ( curr == fLeaf ) return true;
    for (auto edge : edges[curr])
    {
        int next = edge.e;
        int nomE = edge.nom;

        bool flag = dfsFindLongest(next);
        if ( flag )
        {
            brMinavane[nomE] = 1;
            return true;
        }
    }
    return false;
}
void bfsFindLongest()
{

    q.push(1);
    while (!q.empty())
    {
        int curr = q.front();
        q.pop();

        if ( edges[curr].size() == 0 && dist[curr] > longest )
        {
            fLeaf = curr;
            longest = dist[curr];
        }

        for (auto edge : edges[curr])
        {
            int next = edge.e;
            int weight = edge.w;

            dist[next] = dist[curr] + weight;
            q.push(next);
        }
    }
    dfsFindLongest(1);
}

int P;
void bfs()
{
    ans = 0;
    q.push(1);
    while (!q.empty())
    {
        int curr = q.front();
        q.pop();
        for (auto edge : edges[curr])
        {
            int next = edge.e;
            int weight = edge.w;
            int nomE = edge.nom;

            if ( weight + P < brMinavane[nomE] * weight )
            {
                ans += (weight + P);
            }
            else
            {
                ans += (brMinavane[nomE] * weight) ;
            }
            q.push(next);
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;


    for (int h=0; h<T; h++)
    {
        int n;
        cin >> n;
        for (int j=0; j<n-1; j++)
        {
            int a, b, l;
            cin >> a >> b >> l;
            edges[a].push_back({b, l, j});
            brMinavane[j] = 2;
        }
        dist[1] = 0;
        int fLeaf = -1;
        int longest = 0;
        bfsFindLongest();
        int Q;
        cin >> Q;
        for (int g=0; g < Q; g++)
        {
            cin >> P;
            bfs();
            cout << ans << endl;
        }


    }
}
/**
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
---------------------
90
100

*/
