#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100008
using namespace std;

struct Edge
{
    long long e, w, nom;
};

vector<Edge> edges[MAXN];
long long brMinavane[MAXN];
long long p;
long long ans;

long long dist[MAXN];
queue<long long> q;
long long fLeaf = -1;
long long longest = 0;
bool dfsFindLongest(long long curr)
{
    if ( curr == fLeaf ) return true;
    for (auto edge : edges[curr])
    {
        long long next = edge.e;
        long long nomE = edge.nom;

        bool flag = dfsFindLongest(next);
        if ( flag )
        {
            brMinavane[nomE] = 1;
            return true;
        }
    }
    return false;
}
void bfsFindLongest()
{

    q.push(1);
    while (!q.empty())
    {
        long long curr = q.front();
        q.pop();

        if ( edges[curr].size() == 0 && dist[curr] > longest )
        {
            fLeaf = curr;
            longest = dist[curr];
        }

        for (auto edge : edges[curr])
        {
            long long next = edge.e;
            long long weight = edge.w;

            dist[next] = dist[curr] + weight;
            q.push(next);
        }
    }
    dfsFindLongest(1);
}

long long P;
void bfs()
{
    ans = 0;
    q.push(1);
    while (!q.empty())
    {
        long long curr = q.front();
        q.pop();
        for (auto edge : edges[curr])
        {
            long long next = edge.e;
            long long weight = edge.w;
            long long nomE = edge.nom;

            if ( weight + P < brMinavane[nomE] * weight )
            {
                ans += (weight + P);
            }
            else
            {
                ans += (brMinavane[nomE] * weight) ;
            }
            q.push(next);
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long T;
    cin >> T;


    for (long long h=0; h<T; h++)
    {
        long long n;
        cin >> n;
        for (long long j=0; j<n-1; j++)
        {
            long long a, b, l;
            cin >> a >> b >> l;
            edges[a].push_back({b, l, j});
            brMinavane[j] = 2;
        }
        dist[1] = 0;
        long long fLeaf = -1;
        long long longest = 0;
        bfsFindLongest();
        long long Q;
        cin >> Q;
        for (long long g=0; g < Q; g++)
        {
            cin >> P;
            bfs();
            cout << ans << endl;
        }


    }
}
/**
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
---------------------
90
100

*/
