#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<set>
#include<queue>
using namespace std;
const int MAX_N=1e5+6;
const long long INF=(1LL<<62);
long long cost[MAX_N];
long long edge[MAX_N];
int parnode[MAX_N];
int paredge[MAX_N];
int in[MAX_N];
int out[MAX_N];
int ver[MAX_N];
int T;
long long d[MAX_N];
vector<pair<int,int>>g[MAX_N];
int n;
bool used[MAX_N];
void DFS(int u,int par)
{
    in[u]=++T;
    ver[T]=u;
    for(auto [v,idx]:g[u])
    {
        if(v==par)continue;
        d[v]=d[u]+edge[idx];
        parnode[v]=u;
        paredge[v]=idx;
        DFS(v,u);
    }
    out[u]=T;
}
void reset()
{
    T=0;
    for(int i=1;i<=n;i++)
    {
        used[i]=0;
        g[i].clear();
        cost[i]=-INF;
    }
}
long long tree[4*MAX_N];
int pos[4*MAX_N];
long long lazy[4*MAX_N];
void Init(int node,int l,int r)
{
    lazy[node]=0;
    if(l==r)
    {
        tree[node]=d[ver[l]];
        pos[node]=l;
        return;
    }
    int mid=(l+r)/2;
    Init(2*node,l,mid);
    Init(2*node+1,mid+1,r);
    if(tree[2*node]>tree[2*node+1])
    {
        tree[node]=tree[2*node];
        pos[node]=pos[2*node];
    }
    else
    {
        tree[node]=tree[2*node+1];
        pos[node]=pos[2*node+1];
    }
}
void push_lazy(int node,int l,int r)
{
    tree[node]-=lazy[node];
    if(l!=r)
    {
        lazy[2*node]+=lazy[node];
        lazy[2*node+1]+=lazy[node];
    }
    lazy[node]=0;
}
void update(int node,int l,int r,int ql,int qr,long long val)
{
    push_lazy(node,l,r);
    if(ql>r or qr<l)return;
    if(ql<=l && r<=qr)
    {
        lazy[node]+=val;
        push_lazy(node,l,r);
        return;
    }
    int mid=(l+r)/2;
    update(2*node,l,mid,ql,qr,val);
    update(2*node+1,mid+1,r,ql,qr,val);
    if(tree[2*node]>tree[2*node+1])
    {
        tree[node]=tree[2*node];
        pos[node]=pos[2*node];
    }
    else
    {
        tree[node]=tree[2*node+1];
        pos[node]=pos[2*node+1];
    }
}
long long sum;
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin>>t;
    while(t--)
    {
        cin>>n;
        reset();
        sum=0LL;
        for(int i=1;i<n;i++)
        {
            int u,v;
            long long e;
            cin>>u>>v>>e;
            edge[i]=e;
            sum+=2LL*e;
            g[u].push_back({v,i});
            g[v].push_back({u,i});
        }
        DFS(1,0);
        Init(1,1,n);
        int cntused=0;
        for(int friends=1;friends<=n;friends++)
        {
            if(cntused==n-1)
            {
                cost[friends]=sum/2;
                continue;
            }
            push_lazy(1,1,n);
            int posfr=pos[1];
            long long dep=tree[1];
            cost[friends]=cost[friends-1]+dep;

            int u=ver[posfr];
            long long curdep=0;
            while(u!=0)
            {
                update(1,1,n,in[u],out[u],dep-curdep);
                if(used[paredge[u]])break;
                used[paredge[u]]=1;
                cntused++;
                curdep+=edge[paredge[u]];
                u=parnode[u];
            }
        }
        int q;
        cin>>q;
        while(q--)
        {
            long long p;
            cin>>p;
            long long ans=INF;
            for(long long friends=1;friends<=n;friends++)
            {
                //if(cost[friends]==-INF)break;
                ans=min(ans,sum-cost[friends]+(friends-1LL)*p);
            }
            if(ans==INF)ans=0;
            cout<<ans<<"\n";
        }
        reset();
    }


    return 0;
}
