#include "gcd5.h"
#include <bits/stdc++.h>

using namespace std;

const long long bound = 1e9;

unordered_map<long long, long long> asked;
set<pair<long long, long long>> positions;

long long myQuery(long long x)
{
    if (asked.find(x) != asked.end())
    {
        return asked[x];
    }

    long long val = query(x);

    positions.insert({x, val});

    return asked[x] = val;
}

pair<long long, long long> makeFunction(long long x1, long long y1, long long x2, long long y2)
{
    if ((y1 - y2) % (x1 - x2) != 0)
    {
        return {bound + 5, bound + 5};
    }

    long long a = (y1 - y2) / (x1 - x2);
    long long b = y1 - a * x1;

    return {a, b};
}

long long lastPos = -1;

pair<long long, long long> findFunction(long long pos)
{
    pair<long long, long long> toSearch = {pos, -bound};
    auto it = positions.lower_bound(toSearch);

    long long x1 = bound + 5;
    long long y1 = bound + 5;
    long long x2 = bound + 5;
    long long y2 = bound + 5;

    if (it == positions.end())
    {
        return {x1, y1};
    }

    x1 = it -> first;
    y1 = it -> second;

    ++it;

    if (it == positions.end())
    {
        return {x2, y2};
    }

    ++it;

    x2 = it -> first;
    y2 = it -> second;

    lastPos = x2;
    return makeFunction(x1, y1, x2, y2);
}

void solve(int n)
{
    long long start = -bound;

    for (int i = 1; i <= n; ++i)
    {
        long long l = start + 4;
        long long r = bound;

        lastPos = -1;
        pair<long long, long long> f = findFunction(start);

        long long x1 = start;
        long long y1 = myQuery(x1);
        long long x2, y2, a, b;

        if (f.first != bound + 5 && f.second != bound + 5 && x1 * f.first + f.second == y1)
        {
            l = lastPos + 1;
            r = bound;
            a = f.first;
            b = f.second;
        }
        else
        {
            x2 = start + 1;
            y2 = myQuery(x2);
            a = (y1 - y2) / (x1 - x2);
            b = y1 - a * x1;

            l = start + 4;
            r = bound;
        }

        while (l <= r)
        {
            long long mid = (l + r) / 2;

            long long curr = myQuery(mid);

            if (a * mid + b == curr)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        answer(a, b);
        start = l;
    }
}
