#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, q;

struct Edge
{
    int to, w;
};

vector<Edge> g[maxn];

long long dp1[maxn];
long long dp2[maxn];
long long dp3[maxn];

int sz = 0;
long long arr[maxn];
long long val[maxn];
long long pref[maxn];
long long suff[maxn];
pair<int, int> edgeForIndex[maxn];

int p;

void dfs(int node, int par)
{
    dp1[node] = dp2[node] = 0;

    if (g[node].size() == 1 && node != 1)
    {
        return;
    }

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i].to;
        int w = g[node][i].w;

        if (to != par)
        {
            dfs(to, node);
            dp1[node] += (2 * w + dp1[to]);
        }
    }

    sz = 0;

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i].to;
        int w = g[node][i].w;

        if (to != par)
        {
            ++sz;
            arr[sz] = 2 * w + dp1[to];
            val[sz] = w + dp2[to];
            edgeForIndex[sz] = make_pair(to, w);
        }
    }

    pref[0] = 0;

    for (int i = 1; i <= sz; ++i)
    {
        pref[i] = pref[i - 1] + arr[i];
    }

    suff[sz + 1] = 0;

    for (int i = sz; i >= 1; --i)
    {
        suff[i] = suff[i + 1] + arr[i];
    }

    dp2[node] = (1LL << 60);

    for (int i = 1; i <= sz; ++i)
    {
        dp2[node] = min(dp2[node], val[i] + pref[i - 1] + suff[i + 1]);
    }

    for (int i = 1; i <= sz; ++i)
    {
        int to = edgeForIndex[i].first;
        int w = edgeForIndex[i].second;
        dp3[node] += min(p + w + dp3[to], 2 * w + dp1[to]);
    }


    for (int i = 1; i <= sz; ++i)
    {
        int to = edgeForIndex[i].first;
        int w = edgeForIndex[i].second;
        long long sum = dp2[to] + w;

        for (int j = 1; j <= sz; ++j)
        {
            if (j != i)
            {
                to = edgeForIndex[j].first;
                w = edgeForIndex[j].second;
                sum += min(p + w + dp3[to], 2 * w + dp1[to]);
            }
        }

        dp3[node] = min(dp3[node], sum);
    }

    //cout << "now :: " << node << " -> " << dp3[node] << endl;
}

void solve()
{
    cin >> n;

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    cin >> q;

    while (q--)
    {
        cin >> p;

        for (int i = 1; i <= n; ++i)
        {
            dp1[i] = dp2[i] = dp3[i] = 0;
        }

        dfs(1, -1);

        cout << min(dp1[1], min(dp2[1], dp3[1])) << "\n";
    }

    for (int i = 1; i <= n; ++i)
    {
        g[i].clear();
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
