#include <bits/stdc++.h>

using namespace std;

const int maxn = 12;

int n, q, p;

struct Edge
{
    int to, w;
};

vector<Edge> g[maxn];

long long dist[maxn][maxn];
vector<int> visitedNodes[maxn][maxn];

void dfs(int root, int node, int par, long long curr)
{
    dist[root][node] = curr;
    visitedNodes[root][node].push_back(node);

    for (auto [to, w] : g[node])
    {
        if (to != par)
        {
            visitedNodes[root][to] = visitedNodes[root][node];
            dfs(root, to, node, curr + w);
        }
    }
}

bool checkBit(int mask, int bit)
{
    return ((mask & (1 << bit)) != 0);
}

int setBit(int mask, int bit)
{
    mask |= (1 << bit);
    return mask;
}

void printMask(int mask)
{
    while (mask > 0)
    {
        cout << mask % 2;
        mask /= 2;
    }
}

long long dp[maxn][(1 << maxn)];

long long f(int mask, int currNode)
{
    if (mask == (1 << n) - 1)
    {
        return 0;
    }

    if (dp[currNode][mask] != -1)
    {
        return dp[currNode][mask];
    }

    long long res = (1LL << 60);

    for (int i = 1; i <= n; ++i)
    {
        if (checkBit(mask, i - 1) == false)
        {
            int newMask = mask;

            for (int j = 0; j < visitedNodes[currNode][i].size(); ++j)
            {
                newMask = setBit(newMask, visitedNodes[currNode][i][j] - 1);
            }

            long long case1 = dist[currNode][i] + f(newMask, i);

            //long long case2 = p + dist[currNode][i] + f(newMask, currNode);

            res = min(res, case1);

            for (int j = 1; j <= n; ++j)
            {
                newMask = mask;

                for (int k = 0; k < visitedNodes[j][i].size(); ++k)
                {
                    newMask = setBit(newMask, visitedNodes[j][i][k] - 1);
                }

                res = min(res, p + dist[j][i] + f(newMask, currNode));
            }
        }
    }

    /*cout << "on " << currNode << " -> ";
    printMask(mask);
    cout << " " << res << " " << p << endl;*/

    return dp[currNode][mask] = res;
}

void solve()
{
    cin >> n;

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    for (int i = 1; i <= n; ++i)
    {
        dfs(i, i, -1, 0);
    }

    cin >> q;

    while (q--)
    {
        cin >> p;

        for (int i = 1; i <= n; ++i)
        {
            for (int mask = 0; mask < (1 << n); ++mask)
            {
                dp[i][mask] = -1;
            }
        }

        int mask = setBit(0, 0);
        cout << f(mask, 1) << "\n";
    }

    for (int i = 1; i <= n; ++i)
    {
        g[i].clear();
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
