#include <bits/stdc++.h>

using namespace std;

const int maxn = 12;

int n, q, p;

struct Edge
{
    int to, w;
};

vector<Edge> g[maxn];

long long dist[maxn][maxn];
vector<int> visitedNodes[maxn][maxn];

void dfs(int root, int node, int par, long long curr)
{
    dist[root][node] = curr;
    visitedNodes[root][node].push_back(node);

    for (auto [to, w] : g[node])
    {
        if (to != par)
        {
            visitedNodes[root][to] = visitedNodes[root][node];
            dfs(root, to, node, curr + w);
        }
    }
}

bool checkBit(int mask, int bit)
{
    return ((mask & (1 << bit)) != 0);
}

int setBit(int mask, int bit)
{
    mask |= (1 << bit);
    return mask;
}

int edgeIndex[maxn][maxn];

long long f(int mask, int currNode)
{
    if (mask == (1 << (n - 1)) - 1)
    {
        return 0;
    }

    long long res = (1LL << 60);

    for (int i = 1; i <= n; ++i)
    {
        if (currNode != i)
        {
            int newMask = mask;

            int prv = currNode;
            bool has = false;

            for (auto node : visitedNodes[currNode][i])
            {
                //cout << currNode << " " << i << " " << prv << " " << node << endl;
                if (prv != node)
                {
                    if (checkBit(newMask, edgeIndex[prv][node] - 1) == false)
                    {
                        has = true;
                    }

                    newMask = setBit(newMask, edgeIndex[prv][node] - 1);
                }

                prv = node;
            }

            if (has) res = min(res, dist[currNode][i] + f(newMask, i));

            for (int friendNode = 1; friendNode <= n; ++friendNode)
            {
                if (friendNode == i)
                {
                    continue;
                }

                int newMask2 = mask;
                int prv = friendNode;
                has = false;

                for (auto node : visitedNodes[friendNode][i])
                {
                    if (node != prv)
                    {
                        if (checkBit(newMask2, edgeIndex[prv][node] - 1) == false)
                        {
                            has = true;
                        }
                        newMask2 = setBit(newMask2, edgeIndex[prv][node] - 1);
                    }

                    prv = node;
                }

                if (has) res = min(res, p + dist[friendNode][i] + f(newMask2, currNode));
            }
        }
    }

    return res;
}

void solve()
{
    cin >> n;

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});

        edgeIndex[x][y] = i;
        edgeIndex[y][x] = i;
    }

    for (int i = 1; i <= n; ++i)
    {
        dfs(i, i, -1, 0);
    }

    cin >> q;

    while (q--)
    {
        cin >> p;

        long long ans = (1LL << 60);

        for (int i = 1; i <= n; ++i)
        {
            int prv = 1;
            int mask = 0;

            for (auto node : visitedNodes[1][i])
            {
                if (prv != node)
                {
                    mask = setBit(mask, edgeIndex[prv][node] - 1);
                }

                prv = node;
            }

            ans = min(ans, f(mask, i) + dist[1][i]);
        }

        cout << ans << "\n";
    }

    for (int i = 1; i <= n; ++i)
    {
        g[i].clear();

        for (int j = 1; j <= n; ++j)
        {
            visitedNodes[i][j].clear();
            dist[i][j] = 0;
            edgeIndex[i][j] = 0;
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}

/*
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100

1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
1
10

2
3
1 2 3
2 3 2
1
1
4
1 2 10
1 3 5
3 4 1
1
1

1
5
1 2 2
1 3 5
1 4 7
3 5 3
1
4

2
4
1 2 2
1 3 5
1 4 7
1
2
5
1 2 2
1 3 5
1 4 7
3 5 3
1
4
*/
